searchNodes=[{"doc":"CubQ is a queue abstraction on top of CubDB. It implements persistent local (double-ended) queue and stack semantics. Usage CubQ is given a CubDB process and a queue identifier upon start: {:ok, db} = CubDB.start_link(data_dir: &quot;my/data/directory&quot;) {:ok, pid} = CubQ.start_link(db: db, queue: :my_queue_id) Queues Queue semantics are implemented by the enqueue/2 and dequeue/1 functions: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :one} CubQ.dequeue(pid) #=&gt; {:ok, :two} # When there are no more elements in the queue, [`dequeue/1`](#dequeue/1) returns `nil`: CubQ.dequeue(pid) #=&gt; nil Note that elements can be any Elixir (or Erlang) term: CubQ.enqueue(pid, %SomeStruct{foo: &quot;bar&quot;}) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, %SomeStruct{foo: &quot;bar&quot;}} The queue is actually double-ended, so elements can be prepended too: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.prepend(pid, :zero) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :zero} Stacks Stack semantics are implemented by the push/2 and pop/1 functions: CubQ.push(pid, :one) #=&gt; :ok CubQ.push(pid, :two) #=&gt; :ok CubQ.pop(pid) #=&gt; {:ok, :two} CubQ.pop(pid) #=&gt; {:ok, :one} # When there are no more elements in the stack, [`pop/1`](#pop/1) returns `nil`: CubQ.pop(pid) #=&gt; nil Mixing things up As the underlying data structure used for stacks and queues is the same, queue and stack semantics can be mixed on the same queue.","ref":"CubQ.html","title":"CubQ","type":"module"},{"doc":"Same as enqueue/2","ref":"CubQ.html#append/2","title":"CubQ.append/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"CubQ.html#child_spec/1","title":"CubQ.child_spec/1","type":"function"},{"doc":"Deletes all elements from the queue. The elements are deleted in batches, and the size of the batch can be specified as the optional second argument.","ref":"CubQ.html#delete_all/2","title":"CubQ.delete_all/2","type":"function"},{"doc":"Removes an element from the beginning of the queue and returns it. It returns {:ok, element} if there are elements in the queue, nil if the queue is empty, and {:error, cause} on error. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :one} CubQ.dequeue(pid) #=&gt; {:ok, :two}","ref":"CubQ.html#dequeue/1","title":"CubQ.dequeue/1","type":"function"},{"doc":"Inserts an element at the end of the queue. The element can be any Elixir (or Erlang) term. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :one}","ref":"CubQ.html#enqueue/2","title":"CubQ.enqueue/2","type":"function"},{"doc":"Returns the element at the beginning of the queue without removing it. It returns {:ok, element} if there are elements in the queue, nil if the queue is empty, and {:error, cause} on error. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.peek_first(pid) #=&gt; {:ok, :one} CubQ.dequeue(pid) #=&gt; {:ok, :one}","ref":"CubQ.html#peek_first/1","title":"CubQ.peek_first/1","type":"function"},{"doc":"Returns the element at the end of the queue without removing it. It returns {:ok, element} if there are elements in the queue, nil if the queue is empty, and {:error, cause} on error. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.peek_last(pid) #=&gt; {:ok, :two} CubQ.pop(pid) #=&gt; {:ok, :two}","ref":"CubQ.html#peek_last/1","title":"CubQ.peek_last/1","type":"function"},{"doc":"Removes an element from the end of the queue and returns it. It returns {:ok, element} if there are elements in the queue, nil if the queue is empty, and {:error, cause} on error. Example: CubQ.push(pid, :one) #=&gt; :ok CubQ.push(pid, :two) #=&gt; :ok CubQ.pop(pid) #=&gt; {:ok, :two} CubQ.pop(pid) #=&gt; {:ok, :one}","ref":"CubQ.html#pop/1","title":"CubQ.pop/1","type":"function"},{"doc":"Inserts an element at the beginning of the queue. The element can be any Elixir (or Erlang) term. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.prepend(pid, :zero) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :zero} CubQ.dequeue(pid) #=&gt; {:ok, :one}","ref":"CubQ.html#prepend/2","title":"CubQ.prepend/2","type":"function"},{"doc":"Same as enqueue/2. Normally used together with pop/1 for stack semantics.","ref":"CubQ.html#push/2","title":"CubQ.push/2","type":"function"},{"doc":"Starts a CubQ process without link. The argument is a keyword list of options, see start_link/1 for details.","ref":"CubQ.html#start/1","title":"CubQ.start/1","type":"function"},{"doc":"Starts a CubQ process linked to the calling process. The argument is a keyword list of options: db (required): the pid (or name) of the CubDB process for storing the queue queue (required): the identifier of the queue. It can be any Elixir term, but typically one would use an atom, like :my_queue GenServer options like name and timeout can also be given, and are forwarded to GenServer.start_link/3 as the third argument.","ref":"CubQ.html#start_link/1","title":"CubQ.start_link/1","type":"function"},{"doc":"","ref":"CubQ.html#t:element/0","title":"CubQ.element/0","type":"type"},{"doc":"","ref":"CubQ.html#t:option/0","title":"CubQ.option/0","type":"type"},{"doc":"","ref":"CubQ.State.html","title":"CubQ.State","type":"module"},{"doc":"","ref":"CubQ.State.html#t:t/0","title":"CubQ.State.t/0","type":"type"}]